
/***************************************************************************/
/***************************************************************************/
/**                                                                       **/
/**  Header Files                                                         **/
/**                                                                       **/
/***************************************************************************/
/***************************************************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include<Windows.h>
#include "const.h"

/***************************************************************************/
/***************************************************************************/
/**                                                                       **/
/**  Constant Definitions                                                 **/
/**                                                                       **/
/***************************************************************************/
/***************************************************************************/

/*
*  Misc. constants
*/
#define N_SEQ     NUM_CONTEXT     /* Number of coding histograms        */
#define N_BSEQ    NUM_BCONTEXT    /* Number of binary coding histograms */

#define UPPER     255             /* Largest possible pixel value       */
#define ERR_SPAN  (UPPER + 1)

/***************************************************************************/
/***************************************************************************/
/**                                                                       **/
/**  Variable Definitions                                                 **/
/**                                                                       **/
/***************************************************************************/
/***************************************************************************/

int tolerance;
int *buf[16];
int ct[16];
/***************************************************************************/
/**                                                                       **/
/**  Function : create_buffer                                             **/
/**                                                                       **/
/***************************************************************************/
static FILE *pre_err[16];
static char exeFullPath[200];
static char error_filename[200], file_indx[2];
static int num_indx;
static int num_cls = 16;
void create_buffer ()
{
	char ran_err_file[200];
	int temp_int = 0; 

	// open the file to store prediction error
	strcpy(ran_err_file,exeFullPath);
	for (num_indx = 1; num_indx <= num_cls; num_indx++)
	{
		strcpy(error_filename, ran_err_file);
		strcat(error_filename, "rpe_c");
		sprintf(file_indx,"%d",num_indx);
		strcat(error_filename, file_indx);
		strcat(error_filename, ".txt");
		if (!(pre_err[num_indx-1] = fopen (error_filename, "r")))
		{
			fprintf (stderr, "ERROR : cannot open rpe%d.txt\n",num_indx);
			exit    (1);
		}
		else {
			fprintf (stderr, ">> read prediction error into rpe%d.txt \n",num_indx);
		}

		if ((buf[num_indx-1] = (int *) calloc (262144, sizeof (int))) == NULL)
		{
			fprintf (stderr, "ERROR : not enough space for buffer!\n");
			exit    (1);
		}
		while (fscanf(pre_err[num_indx-1], "%d\n", &temp_int) != EOF ) 
		{

			buf[num_indx-1][ct[num_indx-1]++]= temp_int;

		}

	}

}

/***************************************************************************/
/**                                                                       **/
/**  Function : destory_buffer                                            **/
/**                                                                       **/
/***************************************************************************/

void destory_buffer ()
	
{

	for (num_indx = 1; num_indx<=num_cls; num_indx++)
	{
		free(buf[num_indx-1]); buf[num_indx-1] = NULL;
		fclose (pre_err[num_indx-1]);
	}	

}



/***************************************************************************/
/***************************************************************************/
/**                                                                       **/
/**  Function : main                                                      **/
/**                                                                       **/
/***************************************************************************/
/***************************************************************************/
//ZN: begin
extern FILE *fStream;
//end

main (argc, argv)
	int argc;
char *argv[];
{
	int H[N_SEQ][ERR_SPAN], BH[N_BSEQ][3];
	short width, height;unsigned char tolerance;
	int ii;
	FILE * img_atrr;
	char error_filename[200]; 
	DWORD len;
	len = GetModuleFileName(NULL, exeFullPath, 200);
	len = WideCharToMultiByte(CP_ACP, 0, exeFullPath, len, error_filename, sizeof(error_filename)-1, NULL, NULL);
	error_filename[len] = '\0';
	strcpy( exeFullPath,error_filename );
	strrchr( exeFullPath, '\\')[0]= 0;
	strcat(exeFullPath,"\\result\\");strcpy(error_filename,exeFullPath);strcat(error_filename,"image_attr.txt");

	if( (fStream=fopen(error_filename,"rb"))==NULL ) {
		fprintf (stderr, "Cannot open image_attr.txt");
		exit    (1);
	}
	else {
		short st;
		unsigned char uct;
		fread(&width,sizeof(short),1,fStream);
		fread(&height,sizeof(short),1,fStream);
		fread(&tolerance,sizeof(unsigned char),1,fStream);
	}
	/*
	*  Check if the number of arguments is correct
	*/

	if( argc!=2 )
	{
		fprintf (stderr, "encode.exe  output_file\n");
		exit    (1);
	}

	//strcpy(error_filename, "..\\..\\");
	strcpy(error_filename,exeFullPath);
	strcat(error_filename, argv[1]);

	if( (fStream=fopen(error_filename,"wb"))==NULL ) {
		fprintf (stderr, "Cannot open %s!\n",argv[1]);
		exit    (1);
	}
	else {
		short st;
		unsigned char uct;
		fprintf (stderr, ">>Compressed into: %s\n",argv[1]);
		fprintf (stderr, ">>Width:%d Height:%d PAE:%d\n",width,height,tolerance);
		st = (short)width;
		fwrite(&st,sizeof(short),1,fStream);
		st = (short)height;
		fwrite(&st,sizeof(short),1,fStream);
		uct = (unsigned char) tolerance;
		fwrite(&uct,1,1,fStream);
	}
	/*
	*  Process the input file
	*/
	
	init_bcoder  ();
	init_scoder  ();
	init_mycoder (tolerance);

	create_buffer  ();

	for (num_indx =0; num_indx<num_cls; num_indx++)
	{
		for(ii=0;ii<ct[num_indx];ii++)
		{

			++H[num_indx][buf[num_indx][ii]];
			encode_symbol (num_indx, buf[num_indx][ii], tolerance);
		}
	}

	destory_buffer ();
	stop_mycoder ();
	//ZN: begin
	{
		int pos;
		pos = ftell(fStream);
		fprintf (stderr, ">>Compressed file size: %d Bytes [%.3f] Bpp\n", pos, (double)pos*8.0/(width*height));
		fclose(fStream);
	}
	//end
}

/***************************************************************************/

