 
/***************************************************************************/
 
/***************************************************************************/
/***************************************************************************/
/**                                                                       **/
/**  File   : shiftbits.c                                                 **/
/**  Date   : April 16, 1996                                              **/
/**                                                                       **/
/***************************************************************************/
/***************************************************************************/
 
 
/***************************************************************************/
/***************************************************************************/
/**                                                                       **/
/**  Header Files                                                         **/
/**                                                                       **/
/***************************************************************************/
/***************************************************************************/
 
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
 
#include "const.h"
#include "coder.h"
#include "stats.h"
 
 
/***************************************************************************/
/***************************************************************************/
/**                                                                       **/
/**  Constant Definitions                                                 **/
/**                                                                       **/
/***************************************************************************/
/***************************************************************************/
 
#define NUM_HIST  NUM_CONTEXT
#define NUM_BHIST NUM_BCONTEXT


/***************************************************************************/
/***************************************************************************/
/**                                                                       **/
/**  Variable Definitions                                                 **/
/**                                                                       **/
/***************************************************************************/
/***************************************************************************/
 
extern int width;
 
int bits_shifted = 0; 
 

/* variable that keeps count of number of times we encode in a histogram */

int tcount[] =
{
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0
};
 
/* variable that keeps sum of symbols encoded in histogram */

double times_tail[] =
{
    0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
    0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
    0.0, 0.0
};
 
/* number of bits currently being shifted out while coding in a histogram */

int aresolution[] =
{
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0
};
 
int ecount = 0;
int pcount = 0;

context *histograms[NUM_HIST];
context *bhistograms[NUM_BHIST];
context *shistograms[6];

int hist_size[9][18] =
{
	{18, 26, 34, 50, 66, 82, 114, 256, 
	 18, 26, 34, 50, 66, 82, 114, 256, 50, 50},  //tau=0 *

	{16, 20, 26, 30, 36, 40, 44,  48,  
	 16, 20, 26, 30, 36, 40, 44,  48,  40, 40}, //tau=1 *

	{12, 10, 12, 10, 12, 12, 14, 20,  
	 12, 10, 12, 10, 12, 12, 14, 20, 50, 50}, //tau=2 *

	{12, 14, 8,  8,  8,  10, 12, 256, 
	 12, 14, 8,  8,  8,  10, 12, 256, 50, 50},            //tau=3 *

	{8, 8, 6,  8, 8,  8,  8, 256, 
	 8, 8, 6,  8, 8,  8,  8, 256, 50, 50}, //tau=4 *

	{8, 8, 8, 10, 12, 10, 20, 10, 
	 8, 8, 8, 10, 12, 10, 20, 10,50, 50},             //tau=5 *

	{14, 12, 10, 12, 12, 20, 20, 50, 
	 14, 12, 10, 12, 12, 20, 20, 50, 50, 50},  //tau=6 *

	{10, 8, 8, 8, 8, 12, 114, 256, 
	 10, 8, 8, 8, 8, 12, 114, 256, 50, 50},       //tau=7 *

	{12, 10, 8, 8, 10, 8, 114, 256, 
	 12, 10, 8, 8, 10, 8, 114, 256, 50, 50},      //tau=8*

}; 
 


/*int hist_size[] =
{
    8, 8, 8, 10, 12, 10, 20, 10,
    8, 8, 8, 10, 12, 10, 20, 10,
    50, 50
};*/
 
int extra_symbols = 0;
 

/***************************************************************************/
/***************************************************************************/
/**                                                                       **/
/**  Misc. operations                                                     **/
/**                                                                       **/
/***************************************************************************/
/***************************************************************************/
  
/***************************************************************************/
/**                                                                       **/
/**  Function : init_bcoder                                               **/
/**                                                                       **/
/***************************************************************************/
 
init_bcoder ()
{
    int i, n;
 
    for (n = 0; n < NUM_BHIST; n++)
    {
        /* create context structure */

        bhistograms[n] = create_context (3, STATIC);

	for (i = 0; i < 3; i++) /* initialise all symbols as having a frequency of 1 */ 
	    install_symbol (bhistograms[n], i);
    }
}
 

/***************************************************************************/
/**                                                                       **/
/**  Function : init_scoder                                               **/
/**                                                                       **/
/***************************************************************************/
 
/* this is new for encoding shifted bits                    */
/* u need to call this from main, both in encode and decode */

init_scoder ()
{
    int i, n, size;
 
    for (size = 2, n = 0; n < 6; n++, size *=2)
    {
        /* create context structure */

        shistograms[n] = create_context (size, STATIC);

	for (i = 0; i < size; i++) /* initialise all symbols as having a frequency of 1 */ 
	    install_symbol (shistograms[n], i);
    }
}


/***************************************************************************/
/**                                                                       **/
/**  Function : init_mycoder                                              **/
/**                                                                       **/
/***************************************************************************/
 
init_mycoder (tolerance)
int tolerance;
{
    int i, n;

	if (tolerance > 8) tolerance = 8;
 
    for (n = 0; n < NUM_HIST; n++)
    {
        /* create context structure */

        histograms[n] = create_context (hist_size[tolerance][n], STATIC);

	for (i = 0; i < hist_size[tolerance][n]; i++) /* initialise all symbols as having a frequency of 1 */ 
	    install_symbol (histograms[n], i);
    }
 
    start_encode        ();
    startoutputtingbits (); 
}


/***************************************************************************/
/**                                                                       **/
/**  Function : stop_mycoder                                              **/
/**                                                                       **/
/***************************************************************************/
 
stop_mycoder ()
{
    finish_encode      ();
    doneoutputtingbits ();
}
 

/***************************************************************************/
/**                                                                       **/
/**  Function : encode_symbol                                             **/
/**                                                                       **/
/***************************************************************************/
 
encode_symbol (hnum, symbol, tolerance)
int hnum, symbol, tolerance;
{
    int i, cnt, shift, snum;
    double avg;

	if (tolerance > 8) tolerance = 8;

    /* check after every 256 symbols coded within histogram */

    if (tcount[hnum] && ((tcount[hnum] % 256) == 0))
    {
        /* reset number if bits being shifted to 0 */

        aresolution[hnum] = 0; 

	/* compute average symbol size in histogram */

	avg = times_tail[hnum] / (tcount[hnum]);
	cnt = 0;

	/* set new number of bits to be shifted, max 6 */

	while((cnt < 4) && (avg >  (0.70*hist_size[tolerance][hnum])))
	{
	    cnt++;
	    avg  /= 2.0;

	    aresolution[hnum]++;
	}

	/* rest count and sum */

	times_tail[hnum] = 0; 
	tcount[hnum]     = 0;
    }

    /* accumulate count and sum */

    times_tail[hnum] += symbol; 
    tcount[hnum]++;

    /* if currently bits being shifted in this histogram */

    if (shift = aresolution[hnum])
    {
        bits_shifted += shift;

	if (shift == 1)
	{
	    snum = symbol & 0x00000001;
	}
	else if (shift == 2)
	{
	    snum = symbol & 0x00000003;
	}
	else if (shift == 3)
	{
	    snum = symbol & 0x00000007;
	}
	else if (shift == 4) 
	{
	    snum = symbol & 0x0000000F;
	}
	else if (shift == 5)
	{
	    snum = symbol & 0x0000001F;
	}
	else if (shift == 6)
	{
	    snum = symbol & 0x0000003F;
	}
	else
	{
	    fprintf (stderr, "Error, shift value > 6!!\n");
	    exit    (1);
	}

	/*
	 *  snum contains shifted bits, encode it using context
	 *  0,1,2,3,4, or 5 for shift bits 1,2,3,4,5 or 6
	 */

	if (encode (shistograms[shift-1], snum) == NOT_KNOWN)
	{
	    fprintf (stderr, "Problem, symbol not in histogram\n");
	    exit    (1);
	}

	symbol = symbol >> shift;
    }

    /* now back to old stuff, once bits are shifted */

    do
    {
        if (symbol >= hist_size[tolerance][hnum] - 1)
	{
	    if (encode (histograms[hnum], hist_size[tolerance][hnum]-1) == NOT_KNOWN)
	    {
	        fprintf (stderr, "Problem, symbol not in histogram\n");
		exit    (1);
	    }

	    symbol -= (hist_size[tolerance][hnum]-1);

	    extra_symbols += 1;

	    if (hnum < NUM_HIST-1) hnum++;
	}
	else break;
    }
    while (1);

    if (encode (histograms[hnum], symbol) == NOT_KNOWN)
    {
        fprintf (stderr, "Problem, symbol not in histogram\n");
	exit    (1);
    }

    ecount++;
}


/***************************************************************************/
/**                                                                       **/
/**  Function : bencode_symbol                                            **/
/**                                                                       **/
/***************************************************************************/
 
bencode_symbol (hnum, symbol)
int hnum, symbol;
{
    if (encode (bhistograms[hnum], symbol) == NOT_KNOWN)
    {
        fprintf (stderr, "Problem, symbol not in bhistogram\n");
	exit    (1);
    }

    ecount++;
}

/***************************************************************************/
/**                                                                       **/
/**  Function : init_mydecoder                                            **/
/**                                                                       **/
/***************************************************************************/
 
init_mydecoder(tolerance)
int tolerance;
{
    int i, n;

	if (tolerance > 8) tolerance = 8;

    for (n = 0; n < NUM_HIST; n++)
    {
        /* create context structure */

        histograms[n] = create_context (hist_size[tolerance][n], STATIC);

	for (i = 0; i < hist_size[tolerance][n]; i++) /* initialise all symbols as having a frequency of 1 */ 
	    install_symbol (histograms[n], i);
    }

    start_decode       ();
    startinputtingbits ();
}


/***************************************************************************/
/**                                                                       **/
/**  Function : init_sdecoder                                             **/
/**                                                                       **/
/***************************************************************************/

init_sdecoder ()
{
    int i, n, size;

    for (size = 2, n = 0; n < 6; n++, size *=2)
    {
        /* create context structure */

        shistograms[n] = create_context (size, STATIC);

	 for (i = 0; i < size; i++) /* initialise all symbols as having a frequency of 1 */
	     install_symbol (shistograms[n], i);
    }
}


/***************************************************************************/
/**                                                                       **/
/**  Function : init_bdecoder                                             **/
/**                                                                       **/
/***************************************************************************/

init_bdecoder ()
{

  int i, n;

    for (n = 0; n < NUM_BHIST; n++)
    {
        /* create context structure */

        bhistograms[n] = create_context (3, STATIC);

	for (i = 0; i < 3; i++) /* initialise all symbols as having a frequency of 1 */ 
	    install_symbol (bhistograms[n], i);
    }
}


/***************************************************************************/
/**                                                                       **/
/**  Function : stop_mydecoder                                            **/
/**                                                                       **/
/***************************************************************************/
 
stop_mydecoder()
{
    finish_decode     ();
    doneinputtingbits ();
}


/***************************************************************************/
/**                                                                       **/
/**  Function : decode_symbol                                             **/
/**                                                                       **/
/***************************************************************************/

decode_symbol (hnum, tolerance)
int hnum, tolerance; 
{
    int i, value, symbol = 0;
    int  cnt, shift, snum, orig_hnum;
    double avg;
 
    orig_hnum = hnum;

	if (tolerance > 8) tolerance = 8;

    if (tcount[hnum] && ((tcount[hnum] % 256) == 0))
    {
        aresolution[hnum] = 0;

	avg = times_tail[hnum] / (tcount[hnum]);
	cnt = 0;

	while ((cnt < 4) && (avg >  (0.70*hist_size[tolerance][hnum])))
	{
	    cnt++;
	    avg /= 2.0;

	    aresolution[hnum]++;
	}

	times_tail[hnum] = 0;
	tcount[hnum]     = 0;
    }
 
    if (shift = aresolution[hnum])
    {
        bits_shifted += shift;

	if ((snum = decode (shistograms[shift-1])) == NOT_KNOWN)
	{
	    fprintf (stderr, "Problem, symbol not in histogram\n");
	    exit    (1);
        }
    }

    do
    {
        if ((value = decode (histograms[hnum])) == NOT_KNOWN)
	{
	    fprintf (stderr, "Problem, symbol not in histogram\n");
	    exit    (1);
	}

	symbol += value;

	if (value == hist_size[tolerance][hnum] - 1)
        {
	    extra_symbols += 1;

	    if (hnum < NUM_HIST - 1) hnum++;
	}
	else break;
    }
    while(1);

    if (shift) symbol = (symbol << shift) | snum;

    pcount++;

    times_tail[orig_hnum] += symbol;
    tcount[orig_hnum]++;

    return (symbol);
}


/***************************************************************************/
/**                                                                       **/
/**  Function : bdecode_symbol                                            **/
/**                                                                       **/
/***************************************************************************/
 
bdecode_symbol (hnum)
int hnum; 
{
    int symbol;

    if ((symbol = decode (bhistograms[hnum])) == NOT_KNOWN)
    {
        fprintf (stderr, "Problem, symbol not in histogram\n");
	exit    (1);
    }

    pcount++;

    return (symbol);
}

/***************************************************************************/
 
